<?php
/*
Plugin Name: Advanced Page List Widget from HashOut
Plugin URI: http://bitsnbytes.hashout.org/downloads/wordpress/plugins/advanced-page-list-widget-plugin/
Description: A replacement for the built in Pages Widget with lots of advanced options.
Version: 0.1
Author: HashOut (Aziz)
Author URI: http://hashout.org/

    Copyright 2008 HashOut (email : hashout@gmail.com)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

function HO_Pages_Install () {
}
register_activation_hook(__FILE__,"HO_Pages_Install");

function HO_Pages_Uninstall () {
	delete_option('widget_HO_Pages');
}
register_deactivation_hook(__FILE__,"HO_Pages_Uninstall");

function widget_HO_Pages_init() {

	// Check for the required API functions
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
		return;

	function widget_HO_Pages($args, $number = 1) {
		extract($args);

		$options = get_option('widget_HO_Pages');

		$title		= empty($options[$number]['title']) ? __('Pages') : $options[$number]['title'];
		$child_of 		= $options[$number]['child_of'];
		$include		= $options[$number]['exclude'];
		$exclude		= $options[$number]['exclude'];
		$authors		= $options[$number]['authors'];
		$meta_key		= $options[$number]['meta_key'];
		$meta_value		= $options[$number]['meta_value'];
		$depth		= $options[$number]['depth'];
		$sort_column	= $options[$number]['sort_column'];
		$sort_order		= $options[$number]['sort_order'];
		$show_date		= $options[$number]['show_date'];
		$date_format	= $options[$number]['date_format'];
		$hierarchical	= $options[$number]['hierarchical'];

		echo $before_widget;
			echo $before_title . $title . $after_title;
			echo "<ul>";

			if (function_exists('wp_list_pages')) {
				$ho_params = "title_li=&";
				if ($child_of)	$ho_params .= "child_of="	. $child_of		. "&";
				if ($include)	$ho_params .= "include="	. $include		. "&";
				if ($exclude)	$ho_params .= "exclude="	. $exclude		. "&";
				if ($authors)	$ho_params .= "authors="	. $authors		. "&";
				if ($meta_key)	$ho_params .= "meta_key="	. $meta_key		. "&";
				if ($meta_value)	$ho_params .= "meta_value="	. $meta_value	. "&";
				if ($depth)		$ho_params .= "depth="		. $depth		. "&";
				if ($sort_column)	$ho_params .= "sort_column="	. $sort_column	. "&";
				if ($sort_order)	$ho_params .= "sort_order="	. $sort_order	. "&";
				if ($show_date)	$ho_params .= "show_date="	. $show_date	. "&";
				if ($date_format)	$ho_params .= "date_format="	. $date_format	. "&";
				if ($hierarchical) $ho_params .= "hierarchical=". $hierarchical	. "&";
				$ho_params = trim($ho_params,"&");
	
				wp_list_pages($ho_params);
			}

			echo "</ul>";
		echo $after_widget;
	} /* widget_HO_Pages */

	function widget_HO_Pages_control($number) {
		global $wpdb;

		$options = $newoptions = get_option('widget_HO_Pages');
		if ( !is_array($options) ) $options = $newoptions = array();
		if ( $_POST["HO_Pages_Submit-$number"] ) {
			$newoptions[$number]['title'] = strip_tags(stripslashes($_POST["HO_Pages_title-$number"]));
			$newoptions[$number]['child_of'] = stripslashes($_POST["HO_Pages_child_of-$number"]);
			$newoptions[$number]['include'] = stripslashes($_POST["HO_Pages_include-$number"]);
			$newoptions[$number]['exclude'] = stripslashes($_POST["HO_Pages_exclude-$number"]);
			$newoptions[$number]['authors'] = stripslashes($_POST["HO_Pages_authors-$number"]);
			$newoptions[$number]['meta_key'] = stripslashes($_POST["HO_Pages_meta_key-$number"]);
			$newoptions[$number]['meta_value'] = stripslashes($_POST["HO_Pages_meta_value-$number"]);
			$newoptions[$number]['depth'] = stripslashes($_POST["HO_Pages_depth-$number"]);
			$newoptions[$number]['sort_column'] = stripslashes($_POST["HO_Pages_sort_column-$number"]);
			$newoptions[$number]['sort_order'] = stripslashes($_POST["HO_Pages_sort_order-$number"]);
			$newoptions[$number]['show_date'] = stripslashes($_POST["HO_Pages_show_date-$number"]);
			$newoptions[$number]['date_format'] = stripslashes($_POST["HO_Pages_date_format-$number"]);
			$newoptions[$number]['hierarchical'] = stripslashes($_POST["HO_Pages_hierarchical-$number"]);
		}
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('widget_HO_Pages', $options);
		}
		$title		= attribute_escape($options[$number]['title']);
		$child_of		= $options[$number]['child_of'];
		$include		= $options[$number]['include'];
		$exclude		= $options[$number]['exclude'];
		$authors		= $options[$number]['authors'];
		$meta_key		= $options[$number]['meta_key'];
		$meta_value		= $options[$number]['meta_value'];
		$depth		= $options[$number]['depth'];
		$sort_column	= $options[$number]['sort_column'];
			$sort_column=='' ? $nosort_selected = ' selected' : '';
		$sort_order		= $options[$number]['sort_order'];
			$sort_order=='asc' ? $asc_selected = ' selected' : '';
			$sort_order=='desc' ? $desc_selected = ' selected' : '';
		$show_date		= $options[$number]['show_date'];
			$nodate_selected = $modified_selected = $created_selected = '';
			if ($show_date=='') $nodate_selected = ' selected';
			else if ($show_date=='modified') $modified_selected = ' selected';
			else $created_selected = ' selected';
		$date_format	= $options[$number]['date_format'];
		$hierarchical	= $options[$number]['hierarchical'];
			$hierarchical_selected = $nothierarchical_selected = '';
			if ($hierarchical=='0') $nothierarchical_selected = ' selected';
			else $hierarchical_selected = ' selected';

		$sql="SHOW COLUMNS FROM $wpdb->posts";
		$rows=$wpdb->get_results($sql);
		$sort_column_options = '';
		if(is_array($rows) && count($rows)>0){
			foreach($rows as $row){
				$sort_column_options .= '<option value="'.$row->Field.'"'.($sort_column==$row->Field?' selected':'').'>'.$row->Field.'</option>';
			}
		}

		echo <<<EOF
<style>
.HO_Pages td {vertical-align:top;}
.HO_Pages .tip {display:inline;color:green;}
</style>
<table class="HO_Pages">
	<tr>
		<td colspan="3"><b>All parameters are optional.</b></td>
	</tr>
	<tr>
		<td><label>Title:</label></td>
		<td><input id="HO_Pages_title-$number" name="HO_Pages_title-$number" type="text" value="$title" /></td>
	</tr>
	<tr>
		<td colspan="3"><br/><b>For the following parameters, refer <a href="http://codex.wordpress.org/wp_list_pages#Parameters" target="_blank">wp_list_pages</a> for help.</b></td>
	</tr>
	<tr>
		<td><label>Child Of:</label></td>
		<td><input id="HO_Pages_child_of-$number" name="HO_Pages_child_of-$number" type="text" value="$child_of" /></td>
		<td class="tip">Enter Page ID</td>
	</tr>
	<tr>
		<td><label>Include:</label></td>
		<td><input id="HO_Pages_include-$number" name="HO_Pages_include-$number" type="text" value="$include" /></td>
		<td class="tip">Page IDs, separated by commas</td>
	</tr>
	<tr>
		<td><label>Exclude:</label></td>
		<td><input id="HO_Pages_exclude-$number" name="HO_Pages_exclude-$number" type="text" value="$exclude" /></td>
		<td class="tip">Page IDs, separated by commas</td>
	</tr>
	<tr>
		<td><label>Authors:</label></td>
		<td><input id="HO_Pages_authors-$number" name="HO_Pages_authors-$number" type="text" value="$authors" /></td>
	</tr>
	<tr>
		<td><label>Custom Field Key:</label></td>
		<td><input id="HO_Pages_meta_key-$number" name="HO_Pages_meta_key-$number" type="text" value="$meta_key" /></td>
		<td class="tip">(meta_key)</td>
	</tr>
	<tr>
		<td><label>Custom Field Value:</label></td>
		<td><input id="HO_Pages_meta_value-$number" name="HO_Pages_meta_value-$number" type="text" value="$meta_value" /></td>
		<td class="tip">(meta_value)</td>
	</tr>
	<tr>
		<td><label>Depth:</label></td>
		<td><input id="HO_Pages_depth-$number" name="HO_Pages_depth-$number" type="text" value="$depth" /></td>
	</tr>
	<tr>
		<td><label>Sort Column:</label></td>
		<td>
			<select id="HO_Pages_sort_column-$number" name="HO_Pages_sort_column-$number">
				<option value=""$nosort_selected>--Default--</option>
				$sort_column_options
			</select>
		</td>
	</tr>
	<tr>
		<td><label>Sort Order:</label></td>
		<td>
			<select id="HO_Pages_sort_order-$number" name="HO_Pages_sort_order-$number">
				<option value="">--Default--</option>
				<option value="asc"$asc_selected>Ascending</option>
				<option value="desc"$desc_selected>Descending</option>
			</select>
		</td>
	</tr>
	<tr>
		<td><label>Show Date:</label></td>
		<td>
			<select id="HO_Pages_show_date-$number" name="HO_Pages_show_date-$number">
				<option value=""$nodate_selected>No</option>
				<option value="modified"$modified_selected>Last Modified</option>
				<option value="created"$created_selected>Created</option>
			</select>
		</td>
	</tr>
	<tr>
		<td><label>Date Format:</label></td>
		<td><input id="HO_Pages_date_format-$number" name="HO_Pages_date_format-$number" type="text" value="$date_format" /></td>
		<td class="tip">For help formatting dates, refer <a href="http://codex.wordpress.org/Formatting_Date_and_Time" target="_blank">WordPress Codex</a> and <a href="http://in2.php.net/date" target="_blank">PHP Date Manual</a></td>
	</tr>
	<tr>
		<td><label>Hierarchical:</label></td>
		<td>
			<select id="HO_Pages_hierarchical-$number" name="HO_Pages_hierarchical-$number">
				<option value=""$hierarchical_selected>Yes</option>
				<option value="0"$nothierarchical_selected>No</option>
			</select>
		</td>
	</tr>
</table>
<input type="hidden" id="HO_Pages_Submit-$number" name="HO_Pages_Submit-$number" value="1" />
EOF;
	} /* widget_HO_Pages_control */

	function widget_HO_Pages_setup() {
		$options = $newoptions = get_option('widget_HO_Pages');
		if ( isset($_POST['HO_Pages_number-submit']) ) {
			$number = (int) $_POST['HO_Pages_number'];
			if ( $number > 9 ) $number = 9;
			if ( $number < 1 ) $number = 1;
			$newoptions['number'] = $number;
		}
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('widget_HO_Pages', $options);
			widget_HO_Pages_register($options['number']);
		}
	} /* widget_HO_Pages_setup */

	function widget_HO_Pages_page() {
		$options = $newoptions = get_option('widget_HO_Pages');
?>
<div class="wrap">
	<form method="POST">
		<h2><?php _e('HashOut Advanced Page List Widgets'); ?></h2>
		<p style="line-height: 30px;"><?php _e('How many HashOut Advanced Page List widgets would you like?'); ?>
		<select id="HO_Pages_number" name="HO_Pages_number">
		<?php for ( $i = 1; $i < 10; ++$i ) echo "<option value='$i' ".($options['number']==$i ? "selected='selected'" : '').">$i</option>"; ?>
		</select>
		<span class="submit"><input type="submit" name="HO_Pages_number-submit" id="HO_Pages_number-submit" value="<?php echo attribute_escape(__('Save')); ?>" /></span></p>
	</form>
</div>
<?php
	} /* widget_HO_Pages_page */

	function widget_HO_Pages_register() {
		$options = get_option('widget_HO_Pages');
		$number = $options['number'];
		if ( $number < 1 ) $number = 1;
		if ( $number > 9 ) $number = 9;
		$dims = array('width' => 600, 'height' => 500);
		$class = array('classname' => 'widget_HO_Pages');
		for ($i = 1; $i <= 9; $i++) {
			$name = sprintf(__('Advanced Page List %d'), $i);
			$id = "HO_Pages-$i"; // Never never never translate an id
			wp_register_sidebar_widget($id, $name, $i <= $number ? 'widget_HO_Pages' : /* unregister */ '', $class, $i);
			wp_register_widget_control($id, $name, $i <= $number ? 'widget_HO_Pages_control' : /* unregister */ '', $dims, $i);
		}
		add_action('sidebar_admin_setup', 'widget_HO_Pages_setup');
		add_action('sidebar_admin_page', 'widget_HO_Pages_page');
	} /* widget_HO_Pages_register */

	widget_HO_Pages_register();

}
add_action('plugins_loaded', 'widget_HO_Pages_init');
?>